/// <reference types="react" />
import { Field, IFieldInputProps } from '../../field';
import { IViewFieldProps, IViewFieldState } from './viewfield.interface';
export declare class ViewField extends Field<IViewFieldProps, IViewFieldState> {
    static readonly defaultProps: IViewFieldProps;
    private previousValue;
    /**
     * @stable [29.07.2019]
     * @param {IViewFieldProps} props
     */
    constructor(props: IViewFieldProps);
    /**
     * @stable [29.07.2019]
     */
    componentWillUnmount(): void;
    /**
     * @stable [29.07.2019]
     * @returns {Promise<void>}
     */
    componentDidMount(): Promise<void>;
    /**
     * @stable [29.07.2019]
     * @param {IViewFieldProps} prevProps
     * @param {IViewFieldState} prevState
     * @returns {Promise<void>}
     */
    componentDidUpdate(prevProps: IViewFieldProps, prevState: IViewFieldState): Promise<void>;
    /**
     * @stable [27.06.2018]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [27.06.2018]
     * @returns {IFieldInputProps}
     */
    protected getInputElementProps(): IFieldInputProps;
    /**
     * @stable [27.06.2018]
     * @returns {JSX.Element}
     */
    private readonly viewElement;
    /**
     * @stable [25.03.2019]
     * @returns {string}
     */
    protected getFieldClassName(): string;
    /**
     * @stable [29.07.2019]
     * @returns {Promise<void>}
     */
    private doRefresh;
    /**
     * @stable [29.07.2019]
     */
    private doClear;
    /**
     * @stable [29.07.2019]
     * @returns {string}
     */
    private readonly currentValue;
}
