"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var URI = require("urijs");
var util_1 = require("../../../util");
var field_1 = require("../../field");
var layout_1 = require("../../layout");
var viewer_1 = require("../../viewer");
var ViewField = /** @class */ (function (_super) {
    __extends(ViewField, _super);
    /**
     * @stable [29.07.2019]
     * @param {IViewFieldProps} props
     */
    function ViewField(props) {
        var _this = _super.call(this, props) || this;
        _this.state = { url: null };
        return _this;
    }
    /**
     * @stable [29.07.2019]
     */
    ViewField.prototype.componentWillUnmount = function () {
        _super.prototype.componentWillUnmount.call(this);
        this.doClear();
    };
    /**
     * @stable [29.07.2019]
     * @returns {Promise<void>}
     */
    ViewField.prototype.componentDidMount = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                _super.prototype.componentDidMount.call(this);
                this.doRefresh();
                return [2 /*return*/];
            });
        });
    };
    /**
     * @stable [29.07.2019]
     * @param {IViewFieldProps} prevProps
     * @param {IViewFieldState} prevState
     * @returns {Promise<void>}
     */
    ViewField.prototype.componentDidUpdate = function (prevProps, prevState) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                _super.prototype.componentDidUpdate.call(this, prevProps, prevState);
                this.doRefresh();
                return [2 /*return*/];
            });
        });
    };
    /**
     * @stable [27.06.2018]
     * @returns {JSX.Element}
     */
    ViewField.prototype.render = function () {
        return (React.createElement("div", { className: this.getFieldClassName() },
            React.createElement(layout_1.FlexLayout, { ref: this.selfRef, className: this.getSelfElementClassName() },
                this.getInputElement(),
                this.viewElement)));
    };
    /**
     * @stable [27.06.2018]
     * @returns {IFieldInputProps}
     */
    ViewField.prototype.getInputElementProps = function () {
        return __assign({}, _super.prototype.getInputElementProps.call(this), { type: 'hidden' });
    };
    Object.defineProperty(ViewField.prototype, "viewElement", {
        /**
         * @stable [27.06.2018]
         * @returns {JSX.Element}
         */
        get: function () {
            var _a = this.props, viewer = _a.viewer, usePreview = _a.usePreview;
            var Component = viewer;
            return (React.createElement(Component, { usePreview: usePreview, src: this.state.url }));
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [25.03.2019]
     * @returns {string}
     */
    ViewField.prototype.getFieldClassName = function () {
        return util_1.toClassName(_super.prototype.getFieldClassName.call(this), 'rac-view-field');
    };
    /**
     * @stable [29.07.2019]
     * @returns {Promise<void>}
     */
    ViewField.prototype.doRefresh = function () {
        return __awaiter(this, void 0, void 0, function () {
            var currentValue, previousValue, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        currentValue = this.currentValue;
                        previousValue = this.previousValue;
                        if (!!R.equals(currentValue, previousValue)) return [3 /*break*/, 3];
                        this.previousValue = currentValue;
                        this.doClear();
                        if (!!R.isNil(currentValue)) return [3 /*break*/, 3];
                        if (!URI(currentValue).is('absolute')) return [3 /*break*/, 1];
                        // The original url from a server
                        this.setState({ url: currentValue });
                        return [3 /*break*/, 3];
                    case 1:
                        _a = this.setState;
                        _b = {};
                        _d = (_c = URL).createObjectURL;
                        return [4 /*yield*/, this.databaseStorage.get(currentValue)];
                    case 2:
                        _a.apply(this, [(_b.url = _d.apply(_c, [_e.sent()]), _b)]);
                        _e.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @stable [29.07.2019]
     */
    ViewField.prototype.doClear = function () {
        var url = this.state.url;
        if (!R.isNil(url)) {
            URL.revokeObjectURL(url);
            this.setState({ url: null });
        }
    };
    Object.defineProperty(ViewField.prototype, "currentValue", {
        /**
         * @stable [29.07.2019]
         * @returns {string}
         */
        get: function () {
            return field_1.toLastAddedMultiItemEntityId(this.value);
        },
        enumerable: true,
        configurable: true
    });
    ViewField.defaultProps = {
        viewer: viewer_1.PictureViewer,
    };
    return ViewField;
}(field_1.Field));
exports.ViewField = ViewField;
//# sourceMappingURL=viewfield.component.js.map