import { INumberConverter } from '../converter';
import { IUIFactory } from '../component/factory/factory.interface';
import { TranslatorT } from '../translation';
import { ISettings } from '../settings';
import { IStorage } from '../storage';
/**
 * @stable [31.10.2018]
 * @returns {INumberConverter}
 */
export declare const getNumberConverter: () => INumberConverter;
/**
 * @stable [09.11.2018]
 * @returns {IUIFactory}
 */
export declare const getUiFactory: () => IUIFactory;
/**
 * @stable [15.11.2018]
 * @returns {TranslatorT}
 */
export declare const getTranslator: () => TranslatorT;
/**
 * @stable [29.07.2019]
 * @returns {ISettings}
 */
export declare const getSettings: () => ISettings;
/**
 * @stable [29.07.2019]
 * @returns {IStorage}
 */
export declare const getDatabaseStorage: () => IStorage;
/**
 * @stable [23.02.2019]
 * @returns {TApi}
 */
export declare const getApi: <TApi>() => TApi;
