import { AnyT, IIdWrapper } from '../definitions.interface';
export interface ISetFileResult extends IIdWrapper<string> {
    filePath: string;
}
export interface IMultiEntityStorageResult {
    addResults: AnyT[];
    removeResults: void[];
}
/**
 * @stable [28.07.2019]
 */
export interface IStorage {
    set(key: string, value: AnyT): Promise<AnyT>;
    get?(key: string): Promise<AnyT>;
    remove?(key: string, noPrefix?: boolean): Promise<void>;
    each?(command: (o: AnyT, key: string) => void): void;
}
export interface IApplicationStorageHelper {
    saveFiles<TEntity>(changes: TEntity, fields: Array<(entity: TEntity) => string>): Promise<IMultiEntityStorageResult[]>;
}
/**
 * @stable [29.07.2019]
 */
export declare const STORAGE_KEY_SEPARATOR = "#";
export declare const STORAGE_APP_STATE_KEY = "$$state";
export declare const STORAGE_APP_TOKEN_KEY: string;
export declare const STORAGE_APP_UUID_KEY: string;
export declare const NOT_VERSIONED_STORAGE_KEY: string;
export declare const VERSIONED_STORAGE_KEY: string;
