"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var dom_1 = require("./dom");
/**
 * @stable [01.08.2019]
 * @param {string} url
 * @param {RequestInit} options
 * @returns {Promise<Blob>}
 */
exports.fromUrlToBlob = function (url, options) {
    return fetch(url, __assign({ mode: 'cors' }, options)).then(function (r) { return r.blob(); });
};
/**
 * @stable [28.06.2018]
 * @param {string} url
 * @param {string} fileName
 * @param {RequestInit} options
 */
exports.downloadBlob = function (url, fileName, options) {
    return exports.fromUrlToBlob(url, options).then(function (blob) { return dom_1.downloadFile(fileName, blob); });
};
//# sourceMappingURL=blob.js.map